#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/param.h>

#include "gmp.h"

#define TEMPNAME	"clickextract.temp"
#define OUTPUTNAME	"clicked_data"
int main(int argc, char **argv)
{
	FILE *source, *swap, *dest;
	char fname[MAXPATHLEN], *smap =NULL, fdest[MAXPATHLEN];
	int size, i, binvalue, len;
	mpz_t datain;

	if(argc != 3)
		return printf("%s is called from stegoreader.sh, go away!\n", *argv);

	fprintf(stderr, "\n\nNew start [%s %s %s]\n", argv[0], argv[1], argv[2]);

	if(!strncmp(argv[1], "clickextract.", 13))
		return printf("%s maybe is not a clickextract.* file...\n", argv[1]);

	if((source =fopen(argv[1], "r")) ==NULL)
	{
		return printf("%s unable to read %s\n", *argv, argv[1]);
	}

	size =atoi(argv[2]);

	if((smap =malloc(size)) ==NULL)
		return printf("unable to alloc memory (%d bytes)\n", size);

	if((fread(smap, size, 1, source)) != 1)
		return printf("unable to read %d bytes from %s\n", size, argv[1]);

	fprintf(stderr, "acqired number with 9 instead of 0: (%d bytes)\n%s\n", size, smap);

	for(i =0; i < size; i++)
	{
		if(smap[i] =='9')
			smap[i] ='0';

		if(smap[i] > '9' || smap[i] < '0')
			smap[i] =0x00;
	}
	smap[size] =0x00;
	fprintf(stderr, "base-9 with 0 instead of 9: %d length\n%s\n", strlen(smap), smap);

	mpz_init(datain);
	mpz_set_str(datain, smap, 9);
	len =mpz_sizeinbase(datain, 9);
	fprintf(stderr, "base-9 size %d, hexdecimal %d\n", len, mpz_sizeinbase(datain, 16));

	sprintf(fname, "%s%s", TEMPNAME, strrchr(argv[1], '.') );
	if((swap =fopen(fname, "w+")) ==NULL)
		return printf("%s unable to create %s temp file\n", *argv, fname);
	sprintf(fdest, "%s%s", OUTPUTNAME, strrchr(argv[1], '.') );
	if((dest =fopen(fdest, "w+")) ==NULL)
		return printf("%s unable to create %s destination file\n", *argv, fdest);

	mpz_out_str(swap, 16, datain);
	fprintf(stderr, "hexdecimal mpz:\n");
	mpz_out_str(stderr, 16, datain);

	/* rewind swap file, read hexdumpped number and convert in binary */
	fseek(swap, SEEK_SET, 0);

	fprintf(stderr, "\nhexdecimal dump:\n");
	while(fscanf(swap, "%02x", &binvalue) != EOF)
	{
		fprintf(stderr, "%02x ", binvalue);
		fputc(binvalue, dest);
	}
	fprintf(stderr, "\n");

	fclose(swap);
	unlink(fname);

	fclose(dest);
	fprintf(stderr, "closed file %s\n", fdest);

	return 0;
}
