#!/bin/sh 

datafile=$1
UA="Mozilla/5.0 (Windows; U; Windows NT 5.1; it; rv:1.8.1.2) Gecko/20070219 Firefox/2.0.0.2"

echo -ne "[+] checking first argument (I'm looking for data file to send)..."
if [  -z $datafile ]; then
	echo -ne " SADNESS\n[-] I'm waiting this arguments: file to send, base url. check README\n"
	exit
fi
echo -ne " OK file $datafile\n"

echo -ne "[+] checking baseurl as 2nd argument, http://www.delirandom.net/ep-mirror/ as example\n"
baseurl=`echo $2 | sed -e's/\/$//g'`
if [ -z $baseurl ]; then
	echo -ne " SADNESS\n[-] I require the baseurl, for generate URL with baseurl/referral and baseurl/link\n"
	exit
fi

echo -ne "[+] using $baseurl as base url\n"
echo -ne "[+] checking stegocode.list..."
if [ ! -f stegocode.list ]; then
	echo -ne " SADNESS\n[-] stegoclicker.sh require file stegocode.list, generated from normalizer.sh\n"
	exit
fi
echo -ne " OK\n"

echo -ne "[+] checking curl executable..."
curlpath=`whereis -b curl | awk {' print $2 '}`
if [ ! -n $curlpath ]; then
	echo -ne " SADNESS\n[-] stegoclicker.sh require curl executable!\n"
	exit
fi
echo -ne " OK:  $curlpath\n"

echo -ne "[+] checking number of stegano code available..."
codenum=`grep -c html stegocode.list`
if [ ! $codenum -ne 0 ]; then
	echo -ne " SADNESS\n[-] stegocode.list doesn't contain '.html'\n "
	exit
fi
echo -ne " OK: $codenum\n"

echo -ne "[+] compression of $datafile, with gzip -9\n"
gzip -9 -c $datafile > $datafile.click_gz
comprfile=$datafile.click_gz

echo -ne "[+] checking length of $comprfile..."
filelen=`du -b $comprfile | awk {' print $1 '}`
if [ ! $filelen -ne 0 ]; then
	echo -ne " SADNESS\n[-] $comprfile has 0 byte length, are you mute ?\n"
	exit
fi
echo -ne " OK: $filelen\n"

# for debug & conversion analysis
rm -f file2click.debug.out
hexdump $comprfile > file2click.debug.out
echo -ne "[+] executing ./file2click $comprfile $filelen $codenum \$RANDOM\n"
# fprintf(stderr) wrote the debug file, printf() the output list
stegolink=`./file2click $comprfile $filelen $codenum $RANDOM 2>>file2click.debug.out`
echo -ne "[+] calling curl at index.html"
curl --user-agent "$UA" -\# $baseurl/index.html >/dev/null
echo -ne "[+] calling curl with referral & code\n"

for x in $stegolink; do \
	echo -ne "$x "
	ref=`head -$x stegocode.list | tail -1 | awk {' printf $2'}`
	link=`head -$x stegocode.list | tail -1 | awk {' printf $3'}`
	curl --user-agent "$UA" -\# -e $baseurl/$ref $baseurl/$link >/dev/null
done

rm -f $comprfile
echo -e "\n[+] done!"
